Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4441)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4442)
@@ -22,10 +22,13 @@
 ! Current revisions:
 ! -----------------
-! Change order of dimension in surface array %frac to allow for better 
-! vectorization.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Change order of dimension in surface array %frac to allow for better 
+! vectorization.
+!
+! 4441 2020-03-04 19:20:35Z suehring
 ! in subroutine chem_init (ECC)
 ! - allows different init paths emission data for legacy
Index: /palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_2d.f90	(revision 4441)
+++ /palm/trunk/SOURCE/data_output_2d.f90	(revision 4442)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! Change order of dimension in surface array %frac to allow for better 
-! vectorization.
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Change order of dimension in surface array %frac to allow for better 
+! vectorization.
+! 
+! 4441 2020-03-04 19:20:35Z suehring
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 4441)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 4442)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! Change order of dimension in surface array %frac to allow for better 
-! vectorization.
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Change order of dimension in surface array %frac to allow for better 
+! vectorization.
+! 
+! 4441 2020-03-04 19:20:35Z suehring
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
Index: /palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4441)
+++ /palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4442)
@@ -21,10 +21,13 @@
 ! Current revisions:
 ! -----------------
-! Change order of dimension in surface array %frac to allow for better 
-! vectorization.
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Change order of dimension in surface array %frac to allow for better 
+! vectorization.
+! 
+! 4441 2020-03-04 19:20:35Z suehring
 ! Major bugfix in calculation of energy demand - floor-area-per-facade was wrongly
 ! calculated leading to unrealistically high energy demands and thus to
Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4441)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4442)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! -----------------
-! Change order of dimension in surface arrays %frac, %emissivity and %albedo 
-! to allow for better vectorization in the radiation interactions.
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Change order of dimension in surface arrays %frac, %emissivity and %albedo 
+! to allow for better vectorization in the radiation interactions.
+! 
+! 4441 2020-03-04 19:20:35Z suehring
 ! bugfix: missing cpp-directives for serial mode added, misplaced cpp-directives moved
 ! 
Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4441)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4442)
@@ -23,11 +23,14 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
 ! - Change order of dimension in surface arrays %frac, %emissivity and %albedo 
 !   to allow for better vectorization in the radiation interactions.
 ! - Minor formatting issues
 ! 
-! Former revisions:
-! -----------------
-! $Id$
+! 4441 2020-03-04 19:20:35Z suehring
 ! bugfixes: cpp-directives for serial mode moved, small changes to get serial mode compiled
 ! 
Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 4441)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 4442)
@@ -21,10 +21,13 @@
 ! Current revisions:
 ! -----------------
-! Change order of dimension in surface array %frac to allow for better 
-! vectorization.
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Change order of dimension in surface array %frac to allow for better 
+! vectorization.
+! 
+! 4441 2020-03-04 19:20:35Z suehring
 ! Bug fixes and reformatting for the restart data and averaged data output
 ! - add missing arrays (averaged data output) in salsa_wrd_local and
Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 4441)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 4442)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! Change order of dimension in surface array %frac to allow for better 
-! vectorization.
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Change order of dimension in surface array %frac to allow for better 
+! vectorization.
+! 
+! 4441 2020-03-04 19:20:35Z suehring
 ! Move 2-m potential temperature output to diagnostic_output_quantities
 ! 
Index: /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4441)
+++ /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4442)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! -----------------
-! Set back turbulent length scale to 8 x grid spacing in the parametrized mode
-! (was accidantly changed).
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Set back turbulent length scale to 8 x grid spacing in the parametrized mode
+! (was accidantly changed).
+! 
+! 4441 2020-03-04 19:20:35Z suehring
 ! Correct misplaced preprocessor directive
 ! 
Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4441)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4442)
@@ -23,10 +23,13 @@
 ! Current revisions:
 ! ------------------
-! Change order of dimension in surface arrays %frac, %emissivity and %albedo 
-! to allow for better vectorization in the radiation interactions.
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Change order of dimension in surface arrays %frac, %emissivity and %albedo 
+! to allow for better vectorization in the radiation interactions.
+! 
+! 4441 2020-03-04 19:20:35Z suehring
 ! Removed wall_flags_static_0 from USE statements as it's not used within
 ! the module