Index: palm/trunk/TESTS/cases/rans_tkee/MONITORING/rans_tkee_rc
===================================================================
--- palm/trunk/TESTS/cases/rans_tkee/MONITORING/rans_tkee_rc	(revision 4327)
+++ 	(revision )
@@ -1,249 +1,0 @@
-
-
-
-1D run control output:
-------------------------------
-
-ITER.   HH:MM:SS    DT      UMAX   VMAX    U*   ALPHA   ENERG.
--------------------------------------------------------------
-      0 00:00:00    0.01    3.00   0.10  0.100   45.0     4.45
-   3325 12:00:04   12.30    3.36   0.87  0.127   26.2     4.48
-
- ******************************    --------------------------------------------
- * PALM 6.0  Rev: 4325M       *    atmosphere - run with 1D - prerun
- ******************************    --------------------------------------------
-
- Date:               2019-12-06    Run:       rans_tkee__gfortran_default__4    
- Time:                 12:04:59    Run-No.:   00
- Run on host:        gfortran_d
- Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
- ------------------------------------------------------------------------------
-
- Numerical Schemes:
- -----------------
-
- --> Use the TKE-e turbulence closure (RANS mode).
- --> Use the boussinesq approximation for the model equations.
- --> Solve perturbation pressure via multigrid method (w-cycle)
-     number of grid levels:                    4
-     Gauss-Seidel red/black iterations:        2
-     fixed number of multigrid cycles:           2
-     perturbation pressure is calculated at every Runge-Kutta step
- --> Momentum advection via Wicker-Skamarock-Scheme 5th order
- --> Scalar advection via Wicker-Skamarock-Scheme 5th order
- --> Loop optimization method: cache
- --> Time differencing scheme: runge-kutta-3       
- ------------------------------------------------------------------------------
-
-
- Run time and time step information:
- ----------------------------------
-
- Timestep:             variable     maximum value: 20.000 s    CFL-factor: 0.90
- Start time:              0.000 s
- End time:               50.000 s
-
-
- Computational grid and domain size:
- ----------------------------------
-
- Grid length:      dx =      10.000 m    dy =      10.000 m
-                dz(1) =      10.000 m
-                dz(2) =     999.000 m
-
- Domain size:       x =    320.000 m     y =    320.000 m  z(u) =    965.000 m
-
-
-
- Number of gridpoints (x,y,z):  (0:  31, 0:  31, 0:  97)
- Subdomain size (x,y,z):        (    16,     16,     98)
-
-
-    Characteristic levels of the geo. wind component ug:
-
-       Height:         0.0     0.0  m
-       ug:            3.00    3.00  m/s
-       Gradient:    ------    0.00  1/100s
-       Gridpoint:        0       0
-
-    Characteristic levels of the geo. wind component vg:
-
-       Height:         0.0     0.0  m
-       vg:            0.00    0.00  m/s
-       Gradient:    ------    0.00  1/100s
-       Gridpoint:        0       0
-
-
- Topography information:
- ----------------------
-
- Topography: read_from_file                          
- Topography grid definition convention:
- cell center (scalar grid points)
-
-
-
- Boundary conditions:
- -------------------
-
-                     p                    uv                                  pt
-
- B. bound.: p(0)     = p(1)   | uv(0)     = -uv(1)                | pt(0)     = pt(1)            
- T. bound.: p(nzt+1) = 0      | uv(nzt+1) = ug(nzt+1), vg(nzt+1)  | pt(nzt+1) = pt(nzt) + dpt/dz_
-
-                     e
-
- B. bound.: e(0)     = e(1)                                                                      
- T. bound.: e(nzt+1) = e(nzt) = e(nzt-1)                                                         
-
- Bottom surface fluxes are used in diffusion terms at k=1
-       Predefined constant heatflux:    0.001000 K m/s
-
-
-    Constant flux layer between bottom surface and first computational u,v-level:
-
-       z_mo =   5.00 m   z0 = 0.1000 m   z0h = 0.10000 m   kappa = 0.40
-       Rif value range:     -20.00 <= rif <= 20.00
-
-
- Lateral boundaries:
-       left/right:  dirichlet/radiation 
-       north/south: cyclic              
-
-       use_cmax: T
-       pt damping layer width =     0.00 m, pt damping factor = 0.0000
-
-
- Initial profiles:
- ----------------
-
-    Characteristic levels of the initial temperature profile:
-
-       Height:           0.0     0.0  m
-       Temperature:   300.00  300.00  K
-       Gradient:      ------    0.00  K/100m
-       Gridpoint:          0       0
-
-
- List output:
- -----------
-
-    1D-Profiles:
-       Output every             9999999.90 s
-
-
- Data output:
- -----------
-
-
-    1D-Profiles:
-       Output format: netCDF 64bit offset                     
-
-
-       Profile: u, w"u", w*u*, wu, u*2, v, w"v", w*v*, wv, v*2, w, w*2,      
-
-              : e, e*, km, l,                                                
-       Output every                10.00 s
-       Time averaged over           0.00 s
-       Averaging input every        0.00 s
-
-    Time series:
-       Output format: netCDF 64bit offset                     
-
-       Output every                 1.00 s
-
- ------------------------------------------------------------------------------
-
-
- Physical quantities:
- -------------------
-
-    Geograph. latitude  :   latitude  =  52.5 degr
-    Geograph. longitude :   longitude =  13.3 degr
-    Rotation angle      :   rotation_angle =   0.0 degr
-    Angular velocity    :   omega  = 0.729E-04 rad/s
-    Coriolis parameter  :   f      =  0.000116 1/s
-                            f*     =  0.000089 1/s
-
-    Date and time at model start : 2000-01-01 00:00:00 +00
-
-    Gravity             :   g      =  9.8 m/s**2
-
-    Reference state used in buoyancy terms: initial_profile
-
-
- Cloud physics quantities / methods:
- ----------------------------------
-
-
-
- LES / Turbulence quantities:
- ---------------------------
-
-    initial TKE is prescribed as  0.10E+00 (m/s)**2
-    TKE is not allowed to fall below  0.10E-02 (m/s)**2
-    Mixing length is limited to 1.80 * z
-    RANS-mode constants: c_0 =   0.55000
-                         c_1 =   1.44000
-                         c_2 =   1.92000
-                         c_3 =   1.44000
-                         c_4 =   0.00000
-                         sigma_e    =   1.00000
-                         sigma_diss =   1.30000
-
-
- Actions during the simulation:
- -----------------------------
-
-
-
- 1D-Model parameters:
- -------------------
-
-    Simulation time:                    43200.0 s
-    Run-controll output every:          43200.0 s
-    Vertical profile output every:      86400.0 s
-    Mixing length calculation:         blackadar           
-    Dissipation calculation:           prognostic          
-
-
-
- *** dynamic module disabled
-
- ------------------------------------------------------------------------------
-
-
-
-Run-control output:
-------------------
-
-RUN  ITER. HH:MM:SS.SS    DT(E)     UMAX     VMAX     WMAX     U*    W*      THETA*     Z_I     ENERG.   DISTENERG    DIVOLD     DIVNEW     UMAX(KJI)    VMAX(KJI)    WMAX(KJI)   ADVECX   ADVECY   MGCYC
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-  0      0 00:00:00.00   2.6700A   3.3592   0.8728   0.0000  0.127  0.00   0.000E+00      0.  0.442E+01  0.442E-02  0.000E+00  0.000E+00   20  29  29    6  29  29    0  29  29    0.000    0.000       0
-  0      1 00:00:02.67   2.6600A   3.3803   1.5737   1.1399  0.151  0.00  -0.406E-02     10.  0.444E+01  0.438E-02  0.202E-03  0.796E-04   19   7  19    2  14  13    2  13   1    0.000    0.000       2
-  0      2 00:00:05.33   0.2280D   3.3829   1.4716   1.2668  0.147  0.00  -0.469E-02     10.  0.444E+01  0.432E-02  0.137E-03  0.456E-04   19   6  21    2  14  13    2  13   1    0.000    0.000       2
-  0      3 00:00:05.55   0.5210D   3.3841   1.5584   1.3884  0.146  0.00  -0.489E-02      0.  0.444E+01  0.422E-02  0.509E-04  0.117E-04   19   6  22    2  17   0    2  13   1    0.000    0.000       2
-  0      4 00:00:06.07   0.7680D   3.3844   1.5481   1.3903  0.145  0.00  -0.499E-02      0.  0.444E+01  0.408E-02  0.406E-04  0.144E-04   19   5  23    2  17   0    2  13   1    0.000    0.000       2
-  0      5 00:00:06.84   1.0100D   3.3843   1.5249   1.3737  0.144  0.00  -0.512E-02      0.  0.444E+01  0.402E-02  0.452E-04  0.159E-04   19   5  25    2  17   0    2  13   1    0.000    0.000       2
-  0      6 00:00:07.85   1.2400D   3.3841   1.4999   1.3495  0.143  0.00  -0.530E-02      0.  0.444E+01  0.398E-02  0.517E-04  0.120E-04   19   2  28    2  17   0    2  13   1    0.000    0.000       2
-  0      7 00:00:09.09   1.2600D   3.3842   1.4757   1.3212  0.142  0.00  -0.556E-02      0.  0.444E+01  0.394E-02  0.640E-04  0.175E-04   19   0   0    2  17   0    2  13   1    0.000    0.000       2
-  0      8 00:00:10.35   1.3100D   3.3839   1.4629   1.3041  0.141  0.00  -0.562E-02      0.  0.444E+01  0.387E-02  0.619E-04  0.163E-04   19   2   0    2  17   0    2  13   1    0.000    0.000       2
-  0      9 00:00:11.66   1.4100D   3.3834   1.4516   1.2881  0.140  0.00  -0.568E-02      0.  0.444E+01  0.381E-02  0.558E-04  0.154E-04   19   1   0    2  17   0    2  13   1    0.000    0.000       2
-  0     10 00:00:13.07   1.5400D   3.3829   1.4397   1.2708  0.138  0.00  -0.574E-02      0.  0.444E+01  0.376E-02  0.562E-04  0.168E-04   20   2   0    2  17   0    2  13   1    0.000    0.000       2
-  0     11 00:00:14.61   1.7200D   3.3824   1.4277   1.2695  0.137  0.00  -0.587E-02      0.  0.444E+01  0.372E-02  0.579E-04  0.169E-04   20   2   0    2  17   0    1  12   2    0.000    0.000       2
-  0     12 00:00:16.33   1.9600D   3.3819   1.4149   1.2710  0.136  0.00  -0.612E-02      0.  0.444E+01  0.368E-02  0.615E-04  0.179E-04   20   2   0    2  17   0    1  12   2    0.000    0.000       2
-  0     13 00:00:18.29   2.2100D   3.3816   1.4009   1.2651  0.135  0.00  -0.607E-02      0.  0.444E+01  0.364E-02  0.662E-04  0.198E-04   20   2   0    2  17   0    1  12   2    0.000    0.000       2
-  0     14 00:00:20.50   2.3200D   3.3814   1.3877   1.2533  0.134  0.00  -0.602E-02      0.  0.444E+01  0.359E-02  0.696E-04  0.214E-04   19   6  24    2  17   0    1  12   2    0.000    0.000       2
-  0     15 00:00:22.82   2.3300D   3.3814   1.3808   1.2421  0.133  0.00  -0.607E-02      0.  0.444E+01  0.355E-02  0.698E-04  0.221E-04   19   6  24    2  17   0    1  12   2    0.000    0.000       2
-  0     16 00:00:25.15   2.3200D   3.3815   1.3787   1.2335  0.132  0.00  -0.618E-02      0.  0.444E+01  0.351E-02  0.682E-04  0.217E-04   19   7  23    2  17   0    1  12   2    0.000    0.000       2
-  0     17 00:00:27.47   2.3000D   3.3816   1.3779   1.2267  0.131  0.00  -0.628E-02      0.  0.444E+01  0.348E-02  0.664E-04  0.211E-04   19   7  23    2  17   0    1  12   2    0.000    0.000       2
-  0     18 00:00:29.77   2.2900D   3.3818   1.3777   1.2216  0.131  0.00  -0.649E-02      0.  0.444E+01  0.345E-02  0.645E-04  0.206E-04   19   7  23    2  17   0    1  12   2    0.000    0.000       2
-  0     19 00:00:32.06   2.2900D   3.3819   1.3774   1.2173  0.130  0.00  -0.635E-02      0.  0.444E+01  0.343E-02  0.628E-04  0.201E-04   19   7  23    2  17   0    1  12   2    0.000    0.000       2
-  0     20 00:00:34.35   2.2900D   3.3821   1.3767   1.2138  0.129  0.00  -0.628E-02      0.  0.444E+01  0.340E-02  0.614E-04  0.198E-04   19   7  23    2  17   0    1  12   2    0.000    0.000       2
-  0     21 00:00:36.64   2.3000D   3.3823   1.3761   1.2111  0.128  0.00  -0.630E-02      0.  0.444E+01  0.338E-02  0.602E-04  0.195E-04   19   8  23    2  17   0    1  12   2    0.000    0.000       2
-  0     22 00:00:38.94   2.3100D   3.3824   1.3752   1.2086  0.128  0.00  -0.636E-02      0.  0.444E+01  0.336E-02  0.593E-04  0.193E-04   19   8  23    2  17   0    1  12   2    0.000    0.000       2
-  0     23 00:00:41.25   2.3100D   3.3826   1.3743   1.2067  0.127  0.00  -0.646E-02      0.  0.444E+01  0.334E-02  0.585E-04  0.192E-04   19   8  23    2  17   0    1  12   2    0.000    0.000       2
-  0     24 00:00:43.56   2.3200D   3.3828   1.3737   1.2054  0.127  0.00  -0.655E-02      0.  0.444E+01  0.332E-02  0.576E-04  0.190E-04   19   8  24    2  17   0    1  12   2    0.000    0.000       2
-  0     25 00:00:45.88   2.3200D   3.3829   1.3730   1.2040  0.126  0.00  -0.652E-02      0.  0.444E+01  0.330E-02  0.570E-04  0.188E-04   19   8  24    2  17   0    1  12   2    0.000    0.000       2
-  0     26 00:00:48.20   2.3200D   3.3831   1.3725   1.2031  0.126  0.00  -0.647E-02      0.  0.444E+01  0.328E-02  0.563E-04  0.187E-04   19   8  24    2  17   0    1  12   2    0.000    0.000       2
-  0     27 00:00:50.52   2.3300D   3.3833   1.3722   1.2024  0.126  0.00  -0.643E-02      0.  0.444E+01  0.326E-02  0.557E-04  0.185E-04   19   9  24    2  17   0    1  12   2    0.000    0.000       2
Index: palm/trunk/TESTS/cases/rans_tkee/MONITORING/rans_tkee_rc.000
===================================================================
--- palm/trunk/TESTS/cases/rans_tkee/MONITORING/rans_tkee_rc.000	(revision 4446)
+++ palm/trunk/TESTS/cases/rans_tkee/MONITORING/rans_tkee_rc.000	(revision 4446)
@@ -0,0 +1,249 @@
+
+
+
+1D run control output:
+------------------------------
+
+ITER.   HH:MM:SS    DT      UMAX   VMAX    U*   ALPHA   ENERG.
+-------------------------------------------------------------
+      0 00:00:00    0.01    3.00   0.10  0.100   45.0     4.45
+   3325 12:00:04   12.30    3.36   0.87  0.127   26.2     4.48
+
+ ******************************    --------------------------------------------
+ * PALM 6.0  Rev: 4325M       *    atmosphere - run with 1D - prerun
+ ******************************    --------------------------------------------
+
+ Date:               2019-12-06    Run:       rans_tkee__gfortran_default__4    
+ Time:                 12:04:59    Run-No.:   00
+ Run on host:        gfortran_d
+ Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
+ ------------------------------------------------------------------------------
+
+ Numerical Schemes:
+ -----------------
+
+ --> Use the TKE-e turbulence closure (RANS mode).
+ --> Use the boussinesq approximation for the model equations.
+ --> Solve perturbation pressure via multigrid method (w-cycle)
+     number of grid levels:                    4
+     Gauss-Seidel red/black iterations:        2
+     fixed number of multigrid cycles:           2
+     perturbation pressure is calculated at every Runge-Kutta step
+ --> Momentum advection via Wicker-Skamarock-Scheme 5th order
+ --> Scalar advection via Wicker-Skamarock-Scheme 5th order
+ --> Loop optimization method: cache
+ --> Time differencing scheme: runge-kutta-3       
+ ------------------------------------------------------------------------------
+
+
+ Run time and time step information:
+ ----------------------------------
+
+ Timestep:             variable     maximum value: 20.000 s    CFL-factor: 0.90
+ Start time:              0.000 s
+ End time:               50.000 s
+
+
+ Computational grid and domain size:
+ ----------------------------------
+
+ Grid length:      dx =      10.000 m    dy =      10.000 m
+                dz(1) =      10.000 m
+                dz(2) =     999.000 m
+
+ Domain size:       x =    320.000 m     y =    320.000 m  z(u) =    965.000 m
+
+
+
+ Number of gridpoints (x,y,z):  (0:  31, 0:  31, 0:  97)
+ Subdomain size (x,y,z):        (    16,     16,     98)
+
+
+    Characteristic levels of the geo. wind component ug:
+
+       Height:         0.0     0.0  m
+       ug:            3.00    3.00  m/s
+       Gradient:    ------    0.00  1/100s
+       Gridpoint:        0       0
+
+    Characteristic levels of the geo. wind component vg:
+
+       Height:         0.0     0.0  m
+       vg:            0.00    0.00  m/s
+       Gradient:    ------    0.00  1/100s
+       Gridpoint:        0       0
+
+
+ Topography information:
+ ----------------------
+
+ Topography: read_from_file                          
+ Topography grid definition convention:
+ cell center (scalar grid points)
+
+
+
+ Boundary conditions:
+ -------------------
+
+                     p                    uv                                  pt
+
+ B. bound.: p(0)     = p(1)   | uv(0)     = -uv(1)                | pt(0)     = pt(1)            
+ T. bound.: p(nzt+1) = 0      | uv(nzt+1) = ug(nzt+1), vg(nzt+1)  | pt(nzt+1) = pt(nzt) + dpt/dz_
+
+                     e
+
+ B. bound.: e(0)     = e(1)                                                                      
+ T. bound.: e(nzt+1) = e(nzt) = e(nzt-1)                                                         
+
+ Bottom surface fluxes are used in diffusion terms at k=1
+       Predefined constant heatflux:    0.001000 K m/s
+
+
+    Constant flux layer between bottom surface and first computational u,v-level:
+
+       z_mo =   5.00 m   z0 = 0.1000 m   z0h = 0.10000 m   kappa = 0.40
+       Rif value range:     -20.00 <= rif <= 20.00
+
+
+ Lateral boundaries:
+       left/right:  dirichlet/radiation 
+       north/south: cyclic              
+
+       use_cmax: T
+       pt damping layer width =     0.00 m, pt damping factor = 0.0000
+
+
+ Initial profiles:
+ ----------------
+
+    Characteristic levels of the initial temperature profile:
+
+       Height:           0.0     0.0  m
+       Temperature:   300.00  300.00  K
+       Gradient:      ------    0.00  K/100m
+       Gridpoint:          0       0
+
+
+ List output:
+ -----------
+
+    1D-Profiles:
+       Output every             9999999.90 s
+
+
+ Data output:
+ -----------
+
+
+    1D-Profiles:
+       Output format: netCDF 64bit offset                     
+
+
+       Profile: u, w"u", w*u*, wu, u*2, v, w"v", w*v*, wv, v*2, w, w*2,      
+
+              : e, e*, km, l,                                                
+       Output every                10.00 s
+       Time averaged over           0.00 s
+       Averaging input every        0.00 s
+
+    Time series:
+       Output format: netCDF 64bit offset                     
+
+       Output every                 1.00 s
+
+ ------------------------------------------------------------------------------
+
+
+ Physical quantities:
+ -------------------
+
+    Geograph. latitude  :   latitude  =  52.5 degr
+    Geograph. longitude :   longitude =  13.3 degr
+    Rotation angle      :   rotation_angle =   0.0 degr
+    Angular velocity    :   omega  = 0.729E-04 rad/s
+    Coriolis parameter  :   f      =  0.000116 1/s
+                            f*     =  0.000089 1/s
+
+    Date and time at model start : 2000-01-01 00:00:00 +00
+
+    Gravity             :   g      =  9.8 m/s**2
+
+    Reference state used in buoyancy terms: initial_profile
+
+
+ Cloud physics quantities / methods:
+ ----------------------------------
+
+
+
+ LES / Turbulence quantities:
+ ---------------------------
+
+    initial TKE is prescribed as  0.10E+00 (m/s)**2
+    TKE is not allowed to fall below  0.10E-02 (m/s)**2
+    Mixing length is limited to 1.80 * z
+    RANS-mode constants: c_0 =   0.55000
+                         c_1 =   1.44000
+                         c_2 =   1.92000
+                         c_3 =   1.44000
+                         c_4 =   0.00000
+                         sigma_e    =   1.00000
+                         sigma_diss =   1.30000
+
+
+ Actions during the simulation:
+ -----------------------------
+
+
+
+ 1D-Model parameters:
+ -------------------
+
+    Simulation time:                    43200.0 s
+    Run-controll output every:          43200.0 s
+    Vertical profile output every:      86400.0 s
+    Mixing length calculation:         blackadar           
+    Dissipation calculation:           prognostic          
+
+
+
+ *** dynamic module disabled
+
+ ------------------------------------------------------------------------------
+
+
+
+Run-control output:
+------------------
+
+RUN  ITER. HH:MM:SS.SS    DT(E)     UMAX     VMAX     WMAX     U*    W*      THETA*     Z_I     ENERG.   DISTENERG    DIVOLD     DIVNEW     UMAX(KJI)    VMAX(KJI)    WMAX(KJI)   ADVECX   ADVECY   MGCYC
+---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
+  0      0 00:00:00.00   2.6700A   3.3592   0.8728   0.0000  0.127  0.00   0.000E+00      0.  0.442E+01  0.442E-02  0.000E+00  0.000E+00   20  29  29    6  29  29    0  29  29    0.000    0.000       0
+  0      1 00:00:02.67   2.6600A   3.3803   1.5737   1.1399  0.151  0.00  -0.406E-02     10.  0.444E+01  0.438E-02  0.202E-03  0.796E-04   19   7  19    2  14  13    2  13   1    0.000    0.000       2
+  0      2 00:00:05.33   0.2280D   3.3829   1.4716   1.2668  0.147  0.00  -0.469E-02     10.  0.444E+01  0.432E-02  0.137E-03  0.456E-04   19   6  21    2  14  13    2  13   1    0.000    0.000       2
+  0      3 00:00:05.55   0.5210D   3.3841   1.5584   1.3884  0.146  0.00  -0.489E-02      0.  0.444E+01  0.422E-02  0.509E-04  0.117E-04   19   6  22    2  17   0    2  13   1    0.000    0.000       2
+  0      4 00:00:06.07   0.7680D   3.3844   1.5481   1.3903  0.145  0.00  -0.499E-02      0.  0.444E+01  0.408E-02  0.406E-04  0.144E-04   19   5  23    2  17   0    2  13   1    0.000    0.000       2
+  0      5 00:00:06.84   1.0100D   3.3843   1.5249   1.3737  0.144  0.00  -0.512E-02      0.  0.444E+01  0.402E-02  0.452E-04  0.159E-04   19   5  25    2  17   0    2  13   1    0.000    0.000       2
+  0      6 00:00:07.85   1.2400D   3.3841   1.4999   1.3495  0.143  0.00  -0.530E-02      0.  0.444E+01  0.398E-02  0.517E-04  0.120E-04   19   2  28    2  17   0    2  13   1    0.000    0.000       2
+  0      7 00:00:09.09   1.2600D   3.3842   1.4757   1.3212  0.142  0.00  -0.556E-02      0.  0.444E+01  0.394E-02  0.640E-04  0.175E-04   19   0   0    2  17   0    2  13   1    0.000    0.000       2
+  0      8 00:00:10.35   1.3100D   3.3839   1.4629   1.3041  0.141  0.00  -0.562E-02      0.  0.444E+01  0.387E-02  0.619E-04  0.163E-04   19   2   0    2  17   0    2  13   1    0.000    0.000       2
+  0      9 00:00:11.66   1.4100D   3.3834   1.4516   1.2881  0.140  0.00  -0.568E-02      0.  0.444E+01  0.381E-02  0.558E-04  0.154E-04   19   1   0    2  17   0    2  13   1    0.000    0.000       2
+  0     10 00:00:13.07   1.5400D   3.3829   1.4397   1.2708  0.138  0.00  -0.574E-02      0.  0.444E+01  0.376E-02  0.562E-04  0.168E-04   20   2   0    2  17   0    2  13   1    0.000    0.000       2
+  0     11 00:00:14.61   1.7200D   3.3824   1.4277   1.2695  0.137  0.00  -0.587E-02      0.  0.444E+01  0.372E-02  0.579E-04  0.169E-04   20   2   0    2  17   0    1  12   2    0.000    0.000       2
+  0     12 00:00:16.33   1.9600D   3.3819   1.4149   1.2710  0.136  0.00  -0.612E-02      0.  0.444E+01  0.368E-02  0.615E-04  0.179E-04   20   2   0    2  17   0    1  12   2    0.000    0.000       2
+  0     13 00:00:18.29   2.2100D   3.3816   1.4009   1.2651  0.135  0.00  -0.607E-02      0.  0.444E+01  0.364E-02  0.662E-04  0.198E-04   20   2   0    2  17   0    1  12   2    0.000    0.000       2
+  0     14 00:00:20.50   2.3200D   3.3814   1.3877   1.2533  0.134  0.00  -0.602E-02      0.  0.444E+01  0.359E-02  0.696E-04  0.214E-04   19   6  24    2  17   0    1  12   2    0.000    0.000       2
+  0     15 00:00:22.82   2.3300D   3.3814   1.3808   1.2421  0.133  0.00  -0.607E-02      0.  0.444E+01  0.355E-02  0.698E-04  0.221E-04   19   6  24    2  17   0    1  12   2    0.000    0.000       2
+  0     16 00:00:25.15   2.3200D   3.3815   1.3787   1.2335  0.132  0.00  -0.618E-02      0.  0.444E+01  0.351E-02  0.682E-04  0.217E-04   19   7  23    2  17   0    1  12   2    0.000    0.000       2
+  0     17 00:00:27.47   2.3000D   3.3816   1.3779   1.2267  0.131  0.00  -0.628E-02      0.  0.444E+01  0.348E-02  0.664E-04  0.211E-04   19   7  23    2  17   0    1  12   2    0.000    0.000       2
+  0     18 00:00:29.77   2.2900D   3.3818   1.3777   1.2216  0.131  0.00  -0.649E-02      0.  0.444E+01  0.345E-02  0.645E-04  0.206E-04   19   7  23    2  17   0    1  12   2    0.000    0.000       2
+  0     19 00:00:32.06   2.2900D   3.3819   1.3774   1.2173  0.130  0.00  -0.635E-02      0.  0.444E+01  0.343E-02  0.628E-04  0.201E-04   19   7  23    2  17   0    1  12   2    0.000    0.000       2
+  0     20 00:00:34.35   2.2900D   3.3821   1.3767   1.2138  0.129  0.00  -0.628E-02      0.  0.444E+01  0.340E-02  0.614E-04  0.198E-04   19   7  23    2  17   0    1  12   2    0.000    0.000       2
+  0     21 00:00:36.64   2.3000D   3.3823   1.3761   1.2111  0.128  0.00  -0.630E-02      0.  0.444E+01  0.338E-02  0.602E-04  0.195E-04   19   8  23    2  17   0    1  12   2    0.000    0.000       2
+  0     22 00:00:38.94   2.3100D   3.3824   1.3752   1.2086  0.128  0.00  -0.636E-02      0.  0.444E+01  0.336E-02  0.593E-04  0.193E-04   19   8  23    2  17   0    1  12   2    0.000    0.000       2
+  0     23 00:00:41.25   2.3100D   3.3826   1.3743   1.2067  0.127  0.00  -0.646E-02      0.  0.444E+01  0.334E-02  0.585E-04  0.192E-04   19   8  23    2  17   0    1  12   2    0.000    0.000       2
+  0     24 00:00:43.56   2.3200D   3.3828   1.3737   1.2054  0.127  0.00  -0.655E-02      0.  0.444E+01  0.332E-02  0.576E-04  0.190E-04   19   8  24    2  17   0    1  12   2    0.000    0.000       2
+  0     25 00:00:45.88   2.3200D   3.3829   1.3730   1.2040  0.126  0.00  -0.652E-02      0.  0.444E+01  0.330E-02  0.570E-04  0.188E-04   19   8  24    2  17   0    1  12   2    0.000    0.000       2
+  0     26 00:00:48.20   2.3200D   3.3831   1.3725   1.2031  0.126  0.00  -0.647E-02      0.  0.444E+01  0.328E-02  0.563E-04  0.187E-04   19   8  24    2  17   0    1  12   2    0.000    0.000       2
+  0     27 00:00:50.52   2.3300D   3.3833   1.3722   1.2024  0.126  0.00  -0.643E-02      0.  0.444E+01  0.326E-02  0.557E-04  0.185E-04   19   9  24    2  17   0    1  12   2    0.000    0.000       2